-- ============================================================
-- Table: INTG_HIERARQ
-- ============================================================
CREATE TABLE INTG_HIERARQ(
   NRSEQIMPORT  VARCHAR2(10),
   NMFILIAL     VARCHAR2(50),
   CDCENTROCUS  VARCHAR2(20),
   NMAPROVN1    VARCHAR2(200),
   DSEMAILAPROVN1 VARCHAR2(200),
   NMAPROVN2 VARCHAR2(200),
   DSEMAILAPROVN2 VARCHAR2(200),
   DSSEGMENTO VARCHAR2(200),
   DSSUPERINTEND VARCHAR2(200), 
   DSDIRETORIA VARCHAR2(200),
   DSREGIONAL VARCHAR2(200),
   DSGOP VARCHAR2(200),
   IDIMPORTADO   VARCHAR2(1),
   NRLINHAARQ   NUMBER,
   NRORG             NUMBER 	     DEFAULT         SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO           VARCHAR2(1)     DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_INTG_HIERARQ CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO        DATE                  			NULL,
   DTULTATU          DATE                  			NULL,
   NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
   CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 		NULL,
   NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
   CDOPERULTATU      VARCHAR2(12)    DEFAULT '1'
)
/


-- ============================================================
-- Table: LOG_INTG_HIERARQ
-- ============================================================
CREATE TABLE LOG_INTG_HIERARQ (
     NRSEQIMPORT  VARCHAR2(10),
     DSERRO       VARCHAR2(2000),
     CDOPERADOR   VARCHAR2(12),
     DTIMPORTACAO DATE,
     NRLINHAARQ   NUMBER,
	    NRORG             NUMBER 	     DEFAULT         SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO           VARCHAR2(1)     DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_LOG_INTG_HIERARQ CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO        DATE                  			NULL,
   DTULTATU          DATE                  			NULL,
   NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
   CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 		NULL,
   NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
   CDOPERULTATU      VARCHAR2(12)    DEFAULT '1'
)
/