CREATE OR REPLACE TRIGGER LOG_DFE_MODDOCFISCTPOP
AFTER DELETE OR INSERT OR UPDATE
ON MODDOCFISCTPOP FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(255);
  V_DESC      VARCHAR2(4000);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN

   V_TIPO := '0';
   V_DESC := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' IdEntrSaidOP=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' CdTipoOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDMODDOCFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' CdModDocFisc=' || :OLD.CDMODDOCFISC;
      END IF;

      IF :OLD.IDOBRIGANEXO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdObrigAnexo=' || :OLD.IDOBRIGANEXO;
      END IF;

      IF :OLD.IDBLOQANEXO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdBloqAnexo=' || :OLD.IDBLOQANEXO;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.IDENTRSAIDOP||:OLD.CDTIPOOPER||:OLD.CDMODDOCFISC;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.IDENTRSAIDOP,'!') <> NVL(:NEW.IDENTRSAIDOP,'!')) OR
            (NVL(:OLD.CDTIPOOPER,'!') <> NVL(:NEW.CDTIPOOPER,'!')) OR 
            (NVL(:OLD.CDMODDOCFISC,'!') <> NVL(:NEW.CDMODDOCFISC,'!')) OR 
            (NVL(:OLD.IDOBRIGANEXO,'!') <> NVL(:NEW.IDOBRIGANEXO,'!')) OR
            (NVL(:OLD.IDBLOQANEXO,'!') <> NVL(:NEW.IDBLOQANEXO,'!'))
         THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.IDENTRSAIDOP||:OLD.CDTIPOOPER||:OLD.CDMODDOCFISC;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.IDENTRSAIDOP||:NEW.CDTIPOOPER||:NEW.CDMODDOCFISC;
      END IF;

      IF NVL(:OLD.IDENTRSAIDOP, '!') <>  NVL(:NEW.IDENTRSAIDOP, '!') THEN
         V_DESC := V_DESC || ' IdEntrSaidOP=' || :NEW.IDENTRSAIDOP;
      END IF;

      IF NVL(:OLD.CDTIPOOPER, '!') <>  NVL(:NEW.CDTIPOOPER, '!') THEN
         V_DESC := V_DESC || ' CdTipoOper=' || :NEW.CDTIPOOPER;
      END IF;

      IF NVL(:OLD.CDMODDOCFISC, '!') <>  NVL(:NEW.CDMODDOCFISC, '!') THEN
         V_DESC := V_DESC || ' CdModDocFisc=' || :NEW.CDMODDOCFISC;
      END IF;

      IF NVL(:OLD.IDOBRIGANEXO, '!') <>  NVL(:NEW.IDOBRIGANEXO, '!') THEN
         V_DESC := V_DESC || ' IdObrigAnexo=' || :NEW.IDOBRIGANEXO;
      END IF;

      IF NVL(:OLD.IDBLOQANEXO, '!') <>  NVL(:NEW.IDBLOQANEXO, '!') THEN
         V_DESC := V_DESC || ' IdBloqAnexo=' || :NEW.IDBLOQANEXO;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO, 
                NMRESPOPER, 
                IDTIPOOPER, 
                CDPESQITEM, 
                DSOPERACAO,
                DSRDMUSUOPER, 
                DSENDUSUOPER, 
                DSNMUSUOPER, 
                DSMETUSUOPER, 
                CDORESPOPER)
            VALUES
               ('MODDOCFISCTPOP',
                V_DTOPER, 
                V_USUARIO,
                V_TIPO,
                V_ITPESQ,
                SUBSTR(V_DESC, 0, 400),
                V_DSREMOTEADDR, 
                V_DSREMOTEHOST, 
                V_DSSERVERRDM,
                V_DSSERVMETHOD, 
                V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/
