var Cus03000_AnaliseGerencialCardCongController = function (ScreenService, General, GeneralServices,MessageService) {
    /*global moment, getLocalVar, Configuration*/
	this.setDefaultValues = function (widget) {
	    widget.getField('DTINTERVAL').defaultValue = {
	        formattedStart: moment().format('DD/MM/YYYY'),
	        start: moment().format('DD/MM/YYYY'),
	        formattedEnd: moment().format('DD/MM/YYYY'),
			end: moment().format('DD/MM/YYYY')
	    };
	    widget.applyDefaultValue();
		GeneralServices.retornaTipoCustoPadrao().then(function (callback) {
			widget.currentRow.NMTIPOCUSTOREAL = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
			widget.currentRow.CDTIPOCUSTOREAL = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
		});
		aplicaDataFieldNivel(widget);
	};

	this.filtraFiliais = function (widget) {
	    var cdgrupfili = 'T';
	    widget.getField('NMFILIAL').applyDefaultValue();
		widget.getField('NMSERVICO').applyDefaultValue();
		widget.getField('NMSERVICO').dataSourceFilter = [];
		if (widget.currentRow.CDGRUPFILI) {
			cdgrupfili = widget.currentRow.CDGRUPFILI;
		}
		widget.getField('NMFILIAL').dataSourceFilter = [
		    {
		        name: "CDGRUPFILI",
		        operator: "=",
		        value: cdgrupfili
		    },
		    {
		        name: "CDOPERADOR",
		        operator: "=",
		        value: getLocalVar('CDOPERADOR')
		    }
	    ];
		widget.getField('NMFILIAL').reload();
	};

	this.filtraServicos = function (widget) {
	    widget.getField('NMSERVICO').dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.getField('ALLNMFILIAL').checked ? 'T' : widget.currentRow.NMFILIAL.join('_')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];
		widget.getField('NMSERVICO').clearValue();
		widget.getField('NMSERVICO').reload();
	};

	var validaProduto = function (prodIni, prodFin) {
		if (General.comparaPratoProduto(prodIni, prodFin, getLocalVar('CDPICTPROD'))) {
			return true;
		} else {
			ScreenService.showMessage("Produto inicial deve ser menor ou igual ao produto final.", 'error');
		}
	};
	var montaLista = function (widget, fieldName) {
		if (widget.getField('ALL' + fieldName).checked) {
			return 'T';
		} else {
			var row = widget.currentRow[fieldName];
			if (Array.isArray(row)) {
				return row.join('_');
			}
		}
	};

	this.report = function (widget) {
		if (widget.isValid()) {
			if (validaProduto(widget.currentRow.CDARVPRODINI, widget.currentRow.CDARVPRODFIN)) {
                widget.currentRow.CDTIPOPRAT   = montaLista(widget, 'NMTIPOPRAT');
				
                widget.currentRow.CDFILIAL    = montaLista(widget, 'NMFILIAL');
                widget.currentRow.CDSERVFILI  = montaLista(widget, 'NMSERVICO');
                widget.currentRow.DTINICIAL   = widget.currentRow.DTINTERVAL.start;
                widget.currentRow.DTFINAL     = widget.currentRow.DTINTERVAL.end;
                widget.currentRow.DSTIPOCUSTO = widget.currentRow.NMTIPOCUSTOREAL;
                widget.currentRow.NIVELINDICE = widget.currentRow.TIPONIVEL;
                widget.currentRow.CDGRUPFILI  = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : null;
                var formats = [
					{
						name: "pdf",
						value: "PDF"
					},
					{
						name: "xlsx",
						value: "XLSX"
					}
				];

				General.openReportPopup(widget, this.confirmReport, [widget.currentRow], formats);
			}
		}
	};
	this.confirmReport = function (row) {
		General.openReport('cus_relatorio#/cus03000_analise_gerencial_card_cong', row.CDREPORT, row);
	};
	
    this.bindOutDataCurrentRow = function(field){
        let widget  = field.widget;
        let outData = field._outData;
        if(outData){
            Object.keys(outData).forEach(function(property){
                widget.currentRow[outData[property]] = outData[property] === field.name ? 
                    widget.currentRow[outData[property]] : widget.currentRow[property];
            });
        }
        
        if(field.name === 'NMPRODUTOINI'){
        	widget.currentRow.NMPRODUTOFIN = angular.copy(widget.currentRow.NMPRODUTOINI);
        	widget.currentRow.CDPRODUTOFIN = angular.copy(widget.currentRow.CDPRODUTOINI);
        	widget.currentRow.CDARVPRODFIN = angular.copy(widget.currentRow.CDARVPRODINI);
        }
    };
    
    var aplicaDataFieldNivel = function(widgetMain) {
       var nivelMascara = General.getLevelByMask("CDPICTPROD", 1);
        var data = [
            {
                name: ScreenService.i18n("Nível 0"),
                value: "0"
            }
        ];
            
        MessageService.getMessageByCode("MSG_NIVEL").then(message => {
            for (var posicao = 0; posicao < nivelMascara.length - 2; posicao++) {
                    data.push({
                        name:  ScreenService.i18n(message,{"PARAMETRO":nivelMascara[posicao].nivel}),
                        value: nivelMascara[posicao].caracteres
                    });
            }
            widgetMain.getField("TIPONIVEL").dataSource.data = data;
        });
       
    };
    
    this.onChangeCheckbox = function(args){
    	let widget = args.owner.field.widget;
    	let cRow = widget.currentRow;
    	if(args.owner.field.name == 'ALLNMFILIAL'){
	    	if(cRow.ALLNMFILIAL == 'T') {
	    		this.setReadOnlyOnField('NMFILIAL', true, widget);
	            this.setRequiredField('NMFILIAL', false, widget);
	            cRow.NMFILIAL = [];
	    	 } else {
	            this.setReadOnlyOnField('NMFILIAL', false, widget);
	            this.setRequiredField('NMFILIAL', true, widget);
	        }
	        widget.getField('ALLNMFILIAL').reload();
	        this.filtraServicos(widget);
    	} else {
    		if(cRow.ALLNMSERVICO == 'T') {
	    		this.setReadOnlyOnField('NMSERVICO', true, widget);
	            this.setRequiredField('NMSERVICO', false, widget);
	            cRow.NMSERVICO = [];
	    	 } else {
	            this.setReadOnlyOnField('NMSERVICO', false, widget);
	            this.setRequiredField('NMSERVICO', true, widget);
	        }
	        widget.getField('ALLNMSERVICO').reload();
    	}
    };
    
    this.setReadOnlyOnField = function (field, state, fieldWidget) {
        if (typeof field == "string") {
            field = fieldWidget.getField(field);
        }
        field.readOnly = state;
    };
    
    this.setRequiredField = function (field, state, fieldWidget) {
        if (typeof field == "string") {
            field = fieldWidget.getField(field);
        }

        if (state) {

            if (field.validations) {
                field.validations.required = true;
            } else {
                field.validations = {
                    required: true
                };
            }

        } else {
            delete field.validations.required;
        }
    };
    
};
Configuration(function (ContextRegister) {
	ContextRegister.register('Cus03000_AnaliseGerencialCardCongController', Cus03000_AnaliseGerencialCardCongController);
});